const Script = require('vm').Script;
module.exports = (code = () => { }, $globals) => {
    let globals = {};
    const restrict = [
        "require",
        "process",
        "setTimeout",
        "clearTimeout",
        "setImmediate",
        "clearImmediate",
        "setInterval",
        "clearInterval",
        "console"
    ];
    restrict.forEach(name => globals[name] = typeof ($globals[name]) !== "undefined" ? $globals[name] : undefined);
    globals.Buffer = Buffer;
    globals.exports = {};
    globals.__filename = `$_Virtual_File_$`;
    globals.__dirname = `$_Virtual_Directory_$`;
    globals = Object.assign({}, globals, $globals);
    globals.module = {
        exports: globals.exports,
        require: globals.require,
        id: globals.__filename,
        filename: globals.__filename,
        parent: undefined
    };
    globals.global = globals;
    const opts = {
        filename: globals.__filename,
        displayErrors: true
    };
    const script = new Script(code, opts);
    script.runInNewContext(globals, opts);
    return (globals.module.exports);
};